package com.gloabalexceptionhandling.Controller;

import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import com.gloabalexceptionhandling.Model.Student;
import org.springframework.beans.factory.annotation.Autowired;
import com.gloabalexceptionhandling.Service.StudentServiceImpl;

import java.util.List;

import static org.springframework.http.HttpStatus.CREATED;
import static org.springframework.http.HttpStatus.OK;

@RestController
public class StudentController {

    @Autowired
    private StudentServiceImpl studentService;

    @GetMapping("/students")
    public List<Student> getAllStudents() {
        return this.studentService.getAllStudents();
    }

    @GetMapping("/students/{id}")
    public ResponseEntity<?> getStudentByID(@PathVariable("id") int id) {
        Student getStudent = studentService.getStudentByID(id);
        return  new ResponseEntity<Student>(getStudent, OK);
    }

    @PostMapping("/students")
    public ResponseEntity<?>  addStudent(@RequestBody Student student) {
        Student st = this.studentService.addStudent(student);
        return new ResponseEntity<Student>(st, CREATED);
    }

    @PutMapping("/students/{studentId}")
    public Student updateStudent(@RequestBody Student student, @PathVariable("studentId")int studentId) {
        this.studentService.updateStudent(student, studentId);
        return student;
    }

    @DeleteMapping("/students/{studentId}")
    public void deleteStudent(@PathVariable("studentId") int studentId) {
        this.studentService.deleteStudentById(studentId);
    }

}