package com.gloabalexceptionhandling.Service;

import java.util.List;
import java.util.NoSuchElementException;
import org.springframework.stereotype.Service;
import com.gloabalexceptionhandling.Model.Student;
import org.springframework.beans.factory.annotation.Autowired;
import com.gloabalexceptionhandling.Repository.StudentRepository;
import com.gloabalexceptionhandling.Exception.EmptyInputException;

@Service
public class StudentServiceImpl implements StudentService{

    @Autowired
    private StudentRepository studentRepository;

    @Override
    public List<Student> getAllStudents() {
        List<Student> list = (List<Student>) studentRepository.findAll();
        if (list.isEmpty())
            throw new EmptyInputException("604", "Hey List is Completely Empty ......!!");
        return list;
    }

    @Override
    public Student getStudentByID(int id) {
        Student student=  studentRepository.findById(id);
        if (student.getName().length()==0)
            throw new NoSuchElementException("There Is No Student Available for this id ");
        return student;
    }

    @Override
    public Student addStudent(Student st) {
       if (st.getName().isEmpty() || st.getName().length()==0){
           throw new EmptyInputException("601", "Input Field Are Empty....!!");
       }
       Student savestudent = studentRepository.save(st);
       return savestudent;
    }

    @Override
    public void deleteStudentById(int sid) {
    studentRepository.deleteById(sid);
    }


    @Override
    public void updateStudent(Student student, int studentId) {
        student.setId(studentId);
        studentRepository.save(student);
    }

}